#include <Average.h>

int UVOUT = A0; //UV sensor Pin
int motor = A8; //Buzzer Pin
const int ledPin = 13; //checks if device is powered
int uvLevel;
float sensorAverage;
int threshold = 21; //put in a random number, will calibrate later
Average<float> ave(60);//creates an average of the uv values over the last minute

long nextRead;
long nextBuzz;
long now;

int passT;//int that tics up every time you've been 10 seconds past the threshold

void setup() {
  Serial.begin(9600);
  pinMode(ledPin, OUTPUT);
  pinMode(UVOUT, INPUT);
  pinMode(motor, OUTPUT);
}

void loop() {

  digitalWrite(ledPin, HIGH);

  now = millis();
  //event loop that takes the UV sensor's reading once a second and calculates average over the past minute
  if (now > nextRead)
  {
    nextRead = now + 1000;
    uvLevel = analogRead(UVOUT);
    sensorAverage = ave.mean();
    ave.push(uvLevel);
    Serial.print("uvLevel, sensorAverage = ");
    Serial.print(uvLevel);
    Serial.print('\t');
    Serial.println(sensorAverage);
  }

  //event loop that controls the motor, runs once every 10 seconds
  if (now > nextBuzz)
  {
    nextBuzz = now + 10000;
    if (passT > 6 && uvLevel > 0)//if the threshold has been passed for 4 minutes, the motor will continually buzz
    {
      analogWrite(motor, 200);
    }
    else if (passT > 6 && uvLevel == 0)//if the user goes inside, the motor will stop buzzing and "hazard clock" will reset //passT > 24 == outside 4min
    {
      analogWrite(motor, 0);
      passT = 0;
      sensorAverage = 15;
    }
    else if (sensorAverage > threshold)//any time the user is above the reccommended threshold, motor will shortly buzz
    {
      analogWrite(motor, 200);
      delay(500);
      analogWrite(motor, 0);
      passT++;
    }
    else if (sensorAverage == 0)//secondary reset if user goes inside without triggering continuous buzz, once user has been inside for a full minute
    {
      passT = 0;
    }
  }


}
